(** Some simple file content iterations and 
    /usr/bin/test style file status checking functions. *)

open Base

(** {6 Iterators over lines } *)

val iter_lines_exn : string -> (string -> 'a) -> unit
(** [iter_lines_exn filename f] iters [f] over lines of contets of [filename] *)

val iter_lines : string -> (string -> unit) -> (unit, exn) result
(** [iter_lines filename f] iters [f] over lines of contets of [filename] *)

val to_lines : string -> (string list, exn) result
(** [iter_lines filename f] iters [f] over lines of contets of [filename] *)

val to_string : string -> (string, exn) result
(** [to_string filename] returns the contens of the file *)

val open_out : string -> (out_channel -> 'a) -> 'a
(** [open_out filename f] opens [filename] then runs [f] over the opened channel. 
    The channel is closed automatically no matter whether [f] terminates normally
    or raises an exception.
*)

val write_lines : string -> string list -> unit

